datablock AudioProfile(MachShotgun1Sound)
{
   filename    = "./MachShotgunShot1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock DebrisData(MachshotgunShellDebris)
{
	shapeFile = "./MachshotgunShell.dts";
	lifetime = 3;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.8;
	friction = 0.1;
	numBounces = 2;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 3;
};

datablock ParticleData(MachShotgunFlashParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 1.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/dot";
   spinSpeed		   = 0.0;
   spinRandomMin		= 0.0;
   spinRandomMax		= 0.0;
   colors[0]     = "1 1 0.2 0.9";
   colors[1]     = "1 1 0.1 0.5";
   colors[2]     = "1 1 0 0";

   sizes[0]      = 0.10;
   sizes[1]      = 0.05;
   sizes[2]      = 0.00;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = false;
};

datablock ParticleEmitterData(MachShotgunFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 15;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MachShotgunFlashParticle";

   uiName = "Buster Gun Flash";
};

datablock ParticleEmitterData(MachShotgunRicEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 1;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MachShotgunFlashParticle";

   useEmitterColors = true;

   uiName = "Buster Gun Ricochet";
};

AddDamageType("MachShotgun",   '<bitmap:Add-Ons/Weapon_BusterGun/CI_Shotgun> %1',    '%2 <bitmap:Add-Ons/Weapon_BusterGun/CI_Shotgun> %1',0.75,1);
datablock ExplosionData(MachShotgunRicExplosion)
{
   explosionShape = "";
   //soundProfile = "";

   lifeTimeMS = 500;

   debris = "";

   particleEmitter = MachShotgunRicEmitter;
   particleDensity = 10;
   particleRadius = 0.1;
   
   faceViewer     = true;
   explosionScale = "1 1 1";
   
   shakeCamera = false;
   
   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};

datablock ProjectileData(MachShotgunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::MachShotgun;
   radiusDamageType    = $DamageType::MachShotgun;

   explosion           = MachShotgunRicExplosion;
   particleEmitter     = "";
   explodeOnDeath = true;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   muzzleVelocity      = 50;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 10;
   fadeDelay           = 9;
   bounceElasticity    = 0;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = false;
   
   uiName = "Buster Gun Ricochet";
};

//////////
// item //
//////////
datablock ItemData(MachShotgunItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system
   
    // Basic Item Properties
   shapeFile = "./MachShotgun.1.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;
   
   //gui stuff
   uiName = "Buster Gun";
   iconName = "./icon_machshotgun";
   doColorShift = true;
   colorShiftColor = "0.5 0.5 0.5 1.000";
   
    // Dynamic properties defined by the scripts
   image = MachShotgunImage;
   canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MachShotgunImage)
{
   // Basic Item properties
   shapeFile = "./MachShotgun.1.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.10 0.1";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MachShotgunItem;
   ammo = " ";
   projectile = MachShotgunProjectile;
   projectileType = Projectile;

   casing = MachshotgunShellDebris;
   shellExitDir        = vectorNormalize("0.7 0.1 0.4");
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 15.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = "";

   doColorShift = true;
   colorShiftColor = MachShotgunItem.colorShiftColor;
   
   //Raycasting Weapons settings
   raycastWeaponRange = 20;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = MachShotgunProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 10; //Varies based on range
   raycastDirectDamageType = $DamageType::MachShotgun;
   raycastSpreadCount = 5;
   raycastSpreadAmt = 0.008;
   raycastTracerProjectile = "";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 90;
   raycastVerticalImpulse = 60;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]				= "Activate";
	stateTimeoutValue[0]			= 0.4;
	stateWaitForTimeout[0]			= true;
	stateTransitionOnTimeout[0]		= "Ready";
	stateSound[0]				= weaponSwitchSound;
	
	stateName[1]				= "Ready";
	stateTransitionOnTriggerDown[1]		= "Fire";
	stateAllowImageChange[1]		= true;
	stateTimeoutValue[1]			= 0.01;
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Ready";
	stateTimeoutValue[2]            	= 0.3;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Reload";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]				= MachShotgunFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= MachShotgun1Sound;
	stateEjectShell[2]       		= true;
};

function MachShotgunImage::onFire(%this,%obj,%slot)
{
	Parent::onFire(%this,%obj,%slot);
	%obj.playThread(2, plant);
}

function MachShotgunImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
   %this.raycastDirectDamage = mCeil(10-((vectorDist(%obj.getHackPosition(),%pos)/20)*9));
   Parent::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
}

function MachShotgunZombies()
{
   if(isObject(gunImageNoFire))
   {
      $zombie::ammo::Gun[$zombie::ammo::Listcount++] = MachShotgunProjectile;
      $zombie::ammo::AmmoMachShotgunProjectile = 30;
      datablock ShapeBaseImageData(MachShotgunImageNoFire : gunImageNoFire)
      {
         shapeFile = MachShotgunImage.shapeFile;
         RWep = "MachShotgunImage";
         projectile = MachShotgunProjectile;
         doColorShift = MachShotgunItem.doColorShift;
         colorShiftColor = MachShotgunItem.colorShiftColor;
         offset = MachShotgunImage.offset;
      };
   }
}
schedule(100, 0, MachShotgunZombies);